#!/usr/bin/perl
use CGI;

$ROOT = $0;
$ROOT =~ s/\/([^\/]+)$//;
$ROOT .= "/data";

$act     = CGI::param("act");
$path    = CGI::param("path");
$arg     = CGI::param("arg");
$title   = CGI::param("title"); # remark/url title
$url     = CGI::param("url");   # url
$text    = CGI::param("text");  # remark text or url description
$where   = CGI::param("where"); # where to search

# some sanity checks/fixups

$path  =~ s/ /_/g;
$path  =~ s/^\///;
$path  =~ s/\/\.\//\//g;
$path  =~ s/\/?\.\.\//\//g;

if ($path eq "") { $path = "."; }

$act = "index" unless $act;

if (!chdir($ROOT)) { print "Conent-type: text/plain\n\nCannot chdir! ($ROOT) -- press _back_ button"; exit; };
if (!chdir($path)) { print "Content-type: text/plain\n\nCannot chdir to required path! ($path) -- press _back_ button"; exit; }

#############################################################################################
##
##
##

if ( $act eq "mkdir" )
  {
  $arg = fix_path( $arg );
  mkdir( $arg, 0755 );
  print "Location: index.cgi?path=$path\n\n";
  exit;
  };

if ( $act eq "rmdir" )
  {
  $arg = fix_path( $arg );
  rmdir "$arg";
  print "Location: index.cgi?path=$path\n\n";
  exit;
  }

if ( $act eq "del" )
  {
  if ( $arg =~ /^[0-9]+$/ )
    {
    unlink "$arg.txt";
    }
  print "Location: index.cgi?path=$path\n\n";
  exit;
  }

if ( $act eq "search" && $where eq "global" )
  {
  print "Location: index.cgi?path=.&act=search&where=section&arg=" . CGI::escape( $arg ) . "\n\n";
  exit;
  }

#############################################################################################
##
## add/edit new entry
##

if ( $act eq "add" )
  {
  if ( $arg =~ /[0-9]+/ )
    {
    $id = $arg;
    }
  else
    {
    $id = 0;
    do
      {
      # $id = rand();
      $id++;
      $id =~ s/^0\.//;
      } until ! -e "$id.txt";
    };
  open( o, ">$id.txt" );
  print o "$url\n$title\n$text";
  close( o );
  if ( $url )
    {
    print "Location: index.cgi?path=$path\n\n";
    }
  else
    {
    print "Location: index.cgi?path=$path&act=show&arg=$id\n\n";
    }
  exit;
  };

#############################################################################################
##
## print header
##

print "Content-type: text/html\n\n";

print "
  <html>
  <title>WebRemarks</title>
  <body bgcolor=#c0c0c0>


  <hr noshade>
  <table width=100%>
  <td>
  <a href='index.cgi'><img src=home.gif border=0 alt=Home></a>
  </td>
  <td>
  <a href='index.cgi?path=$path&amp;act=edit'><img src=new.gif border=0 alt=Home></a>
  </td>
  <td width=100%>
      <font size=-1>
      <form action=index.cgi>
      <input type=hidden name=path value=$path>
      <input type=hidden name=act value=search>
      Search:
      <input name=arg><br>
      <input type=radio name=where value=section checked> This section and below, or
      <input type=radio name=where value=global> Global search<br>
      </font>
      </form>

  </td>
  <td align=right>
  <!--
  <font size=+15><i><font color=#ff0000>W</font> e b <font color=#ff0000>R</font> e m a r k s</i></font>
  -->
  <img src=webremarks.gif border=0 alt=WebRemarks>
  </td>
  </table>
  <hr noshade>
";

#############################################################################################
##
## show edit dialog for new or existing note
##

if ( $act eq "edit" )
  {
   $arg =~ s/[^0-9]//g;

   print "
   <a href='index.cgi?path=$path&amp;act=show&amp;arg=$arg'><img src=back.gif border=0 alt=Home></a>
   <hr noshade>
   ";

  if ( $arg )
    {
    print "<font color=#880000 size=+1><b>Editing existing note</b></font><br><font size=-1>($arg)</font>";
    }
  else
    {
    print "<font color=#008800 size=+1><b>Adding new note</b></font>";
    }

  $text = "";
  open( i, $arg . ".txt" );
  $url = <i>;
  $title = <i>;
  while(<i>)
    {
    $text .= $_;
    }
  close( i );
  print "
    <b>
    <form action=index.cgi>
    <input type=hidden name=path value=$path>
    <input type=hidden name=act  value=add>
    <input type=hidden name=arg  value=$arg>
    URL (for web bookmarks only):<br>
    <input name=url size=80 value=\"$url\"><br>
    Title:<br>
    <input name=title size=80 value=\"$title\"><br>
    Text or URL description:<br>
    <textarea name=text rows=10 cols=80>$text</textarea>
    <input type=submit value=\"Apply changes\">
    </form>
    </b>
  ";
  }

#############################################################################################
##
## show index
##

if ( $act eq "index" )
  {

  print_index_header( $path );
  print_index_folders();

  ########## print notes/links

  $ln = 0;
  for(<*.txt>)
    {
    $ln++;

    s/\.txt$//;

    $num = $_;

    print_index_remark( $ln, "", $num );
    }
  print_index_footer();
  }

#############################################################################################
##
## show note
##

if ( $act eq "show" )
  {
  $note = $arg;

  $note =~ s/[^0-9]//g;
  $info = "
          <code>
          <font size=-1>
          Folder: <b>$path</b><br>
          Size: <b>" . file_size($note . ".txt") . "</b> chars<br>
          Modified on: " . file_mtime_str($note . ".txt") . "
          </font></code>";
  print "
  <table width=100%>
  <td>
  <a href='index.cgi?path=$path'><img src=back.gif border=0 alt=Home></a>
  </td>
  <td>
  <a href='index.cgi?path=$path&amp;act=edit&amp;arg=$note'><img src=edit.gif border=0 alt=Edit></a>
  </td>
  <td width=100%>
  $info
  </td>
  <td align=right>
  <a href='index.cgi?path=$path&amp;act=del&amp;arg=$note'><img src=delete.gif border=0 alt=Delete></a>
  </td>
  </table>
  <hr noshade size=1>
  ";
  open( i, $note . ".txt" );
  $url = <i>;
  $title = <i>;
  chop( $url );
  chop( $title );
  print "
    <p>
    <table width=100%>
    <tr><td bgcolor=#000000 >&nbsp;<font color=#ffffff size=+1><b>$title</b></font></td></tr>";
  if ( $url ) { print "<tr><td bgcolor=#eeeeee >&nbsp;<font color=#ffffff><code><b><a href=\"$url\">$url</a></b></code></font></td></tr>" };
  print "<tr><td bgcolor=#aaaaaa>&nbsp;<pre>\n";
  while(<i>)
    {
    s/(http:\/\/[\S]+)/<a href=\"$1\">$1<\/a>/gi;
    s/(ftp:\/\/[\S]+)/<a href=\"$1\">$1<\/a>/gi;
    s/^-- /<li>/;
    print;
    }
  close( i );
  print "</pre></td></tr></table><p>\n";
  };

#############################################################################################
##
## show search result index
##

if ( $act eq "search" )
  {

  $arg =~ s/[\~\\\/&;:"`]//g;

  print "
    <code>Search results for <b>`$arg'</b></code>
    <hr noshade>
    ";

  print_index_header( $path );

  ########## print notes/links

  $ln = 0;
  open( i, "grep \"$arg\" -r -l . |" );
  while(<i>)
    {
    chop;
    next unless /^(.+\/)([0-9]+)\.txt$/;

    $ln++;

    print_index_remark( $ln, $1, $2 );
    }
  close( i );
  print_index_footer();

  }

#############################################################################################
##
## print footer
##

print "
  <hr noshade>
  <div align=right>
  <i><font size=-1><b><font color=#ff0000>W</font>eb<font color=#ff0000>R</font>emarks</b> (c) <a href=mailto:cade\@biscom.net>Vladi Belperchinov-Shabanski\"Cade\"</a> 1999</font></i>
  </div>
  </body>
  </html>
  ";

#############################################################################################
##
## subs
##

sub print_index_header
{
  $path = shift;
  $curpath = $path;
  $backpath = $path;
  if ( $curpath eq "." ) { $curpath = "[root]"; };
  $curpath =~ s/^\.\///;
  $backpath =~ s/\/$//;
  $backpath =~ s/\/[^\/]+$//;

  $fcount = `ls -1|wc -l`;
  $rcount = `ls -1 *.txt|wc -l`;
  $fcount -= $rcount;
  $info = "Created on: " . file_mtime_str( "." ) .
          "<br>Folders: <b>$fcount</b>, Remarks: <b>$rcount</b>";

  print "
    <table border=0>
    <tr bgcolor=#ddbbbb>
    <td><a href='index.cgi?path=$backpath'><img src=back.gif border=0 alt=Back></a></td>
    <td><a href='index.cgi?path=$path'><img src=folder.open.gif border=0 alt=OpenFolder></a></td>
    <td width=100%>
    <table width=100%>
      <td width=100%>
      <font size=+1><b>$curpath</b><br><code><font size=-1>$info</font></code></font>
      </td>
      <td>
      <font size=-2><form action=index.cgi>
      <input type=hidden name=path value=$path>
      <input type=hidden name=act value=mkdir>
      New section:<br>
      <input name=arg>
      </form></font>
      </td>
    </table>

    </td>
    <td>&nbsp</td>
    </tr>
  ";
};

sub print_index_footer
{
  print "
  </table>

  </tr>
  </table>
  ";
};

sub print_index_folders
{
  $ln = 0;
  for(<*>)
    {
    $bgcolor = ( $ln % 2 == 0 ) ? "bgcolor=#ddeedd" : "bgcolor=#ccddcc";
    next unless -d $_;
    s/\/$//;
    $folder = $_;
    $count = `ls -1 $folder | wc -l`;
    s/_/ /g;
    $folder2 = $_;
    $ln++;
    print "
      <tr $bgcolor>
      <td><b>$ln.</b></td>
      <td>
      <a href='index.cgi?path=$path/$folder'><img src=folder.gif border=0 alt=Folder></a>
      </td>
      <td width=100%>
      <a href='index.cgi?path=$path/$folder'><font size=+1><b>$folder2</b></font></a> <b>($count)</b>
      </td>
      <td>
      <a href='index.cgi?path=$path&amp;act=rmdir&amp;arg=$folder'><img src=delete.gif border=0 alt=Delete></a>
      </td>
      </tr>
      ";
    }
};

sub print_index_remark
{

  $ln = shift;
  $subpath = shift;
  $num = shift;

  $_path = $path;
  $_path .= "/" . $subpath;
  $_path =~ s/\/\.\//\//g;
  $_path =~ s/\/$//;

  $bgcolor = ( $ln % 2 == 0 ) ? "bgcolor=#bbbbcc" : "bgcolor=#ccccdd";

  $pathlink = "";
  if ( $subpath )
    {
    $pathlink = "<font size=-1><code>In section: <a href=\"index.cgi?path=$_path\">$_path</a></code></font><br>";
    }

    open( fi, "$subpath$num.txt" );
    $url = <fi>;
    $title = <fi>;
    chop( $url );
    chop( $title );
    $text  = "";
    while(<fi>)
      {
      $text .= $_;
      }
    close(fi);

    if ( $url )
      {
       $icon = "link.gif";
       if ( $title eq "" ) { $title = $url };
       if ( $url =~ /^mailto:/ ) { $icon = "mail.gif" }
       if ( $url =~ /^ftp:/ ) { $icon = "ftp.gif" }
       print "
         <tr $bgcolor>
         <td><b>$ln.</b></td>
         <td>
         <a href='index.cgi?path=$_path&amp;act=show&amp;arg=$num'><img src=$icon border=0 alt=Link></a>
         </td>
         <td width=100%>
         <font size=+1><b><a href='$url'>$title</a></b></font><br>$pathlink
         <font size=-1><code><font color=#ff0000>$url</font><br>$text</code></font>
         </td>
         <td>
         <a href='index.cgi?path=$_path&amp;act=edit&amp;arg=$num'><img src=edit.gif border=0 alt=Edit></a>
         </td>
         </tr>
         \n
         ";
      }
    else
      {
       print "
         <tr $bgcolor>
         <td><b>$ln.</b></td>
         <td>
         <a href='index.cgi?path=$_path&amp;act=show&amp;arg=$num'><img src=note.gif border=0 alt=Note></a>
         </td>
         <td width=100%>
         <font size=+1><b><a href='index.cgi?path=$_path&amp;act=show&amp;arg=$num'>$title</a></b></font><br>$pathlink\n
         </td>
         <td>
         <a href='index.cgi?path=$_path&amp;act=edit&amp;arg=$num'><img src=edit.gif border=0 alt=Edit></a>
         </td>
         </tr>
         ";
      }
};

#############################################################################################
##
## extra utilities
##
#############################################################################################

sub file_mtime_str { $a = shift; localtime((stat($a))[9]) }
sub file_size { $a = shift; (stat($a))[7] };

sub fix_path 
{
   $p = shift;
   $p =~ s/ /_/g;
   $p =~ s/[^a-zA-Z\-_0-9+=]+//g;
   $p;
}

sub elog
{
  $msg = shift;
  print stderr "webremarks: ";
  print stderr $msg;
}
#############################################################################################
##
## EOF
##
#############################################################################################
